const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const webhook_subscriptions = sequelize.define(
    'webhook_subscriptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

event_type: {
        type: DataTypes.TEXT,
      
      

      },

enabled: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  webhook_subscriptions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
























































//end loop



    db.webhook_subscriptions.belongsTo(db.webhooks, {
      as: 'webhook',
      foreignKey: {
        name: 'webhookId',
      },
      constraints: false,
    });

    db.webhook_subscriptions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.webhook_subscriptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.webhook_subscriptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return webhook_subscriptions;
};


